<script setup lang="ts">
  const emit = defineEmits<{
    (e: 'close'): void;
  }>();

  const { refreshCart, cartItems, apiError, cartErrors, getAllCarts, isCartLoading } = useCart();
  const { grantedTokenPermission } = usePresentationState();
  const { controlledClient } = useParticipants();
  const { isGuide } = useUser();

  const handleFilter = async (criteria: { order: string; sort: string }) => {
    await getAllCarts(criteria.order, criteria.sort);
  };

  const cartMessage = computed(() => {
    const keys = Object.keys(cartErrors.value ?? {});
    return keys.length > 0 ? cartErrors.value?.[keys[0]]?.message ?? '' : '';
  });

  // it will refresh cart when participant accept permission.
  watch(grantedTokenPermission, () => {
    const value = grantedTokenPermission.value;
    if (!isGuide.value || !value) {
      return;
    }
    if (value === controlledClient.value?.attendeeId) {
      refreshCart();
    }
  });
</script>

<template>
  <InteractionTemplateSidebar
    name="cart-sidebar"
    search-key="label"
    :granted-permission="apiError?.statusCode !== 405"
    :loading="isCartLoading"
    :count="cartItems.length"
    :items="cartItems"
    @close="emit('close')"
    @filter="handleFilter"
  >
    <template #title>
      {{ $t('cart.header') }}
    </template>
    <template #empty-icon>
      <span class="i-sw-solid:shopping-cart" />
    </template>
    <template #empty-label="{ isAllSelected }">
      {{
        !isGuide
          ? $t('cart.emptyCartLabel')
          : isAllSelected
          ? $t('cart.allEmptyCartLabel')
          : $t('cart.guideEmptyCartLabel')
      }}
    </template>
    <template #empty-description="{ isAllSelected }">
      {{
        !isGuide
          ? $t('cart.emptyCartDescription')
          : isAllSelected
          ? $t('cart.allEmptyCartDescription')
          : $t('cart.guideEmptyCartDescription')
      }}
    </template>
    <template #messages>
      <div v-if="cartMessage" class="px-6 pt-3">
        <SwBanner type="inline" variant="warning" :show-close-btn="false">
          {{ cartMessage }}
        </SwBanner>
      </div>
    </template>
    <template #item="{ item, isAllSelected }">
      <ProductCartItem :data="item" :readonly="isAllSelected" />
    </template>
    <template #footer>
      <CartSidebarFooter />
    </template>
  </InteractionTemplateSidebar>
</template>
